#include <DigitalInputCard.hpp>

class Button {
    public:
        Button(DigitalInputCard* inputCard, uint8_t inputPin);
        ~Button();
        void setMinLongPressTime(uint32_t time);
        void setMinShortPressTime(uint32_t time);
        void setLongPressCallback(std::function<void()> callback);
        void setShortPressCallback(std::function<void()> callback);
        void loop();
        void begin();
    private:
        DigitalInputCard* inputCard;
        uint8_t inputPin;
        uint16_t input_handler_id;
        uint32_t shortPressTime;
        uint32_t longPressTime;
        std::function<void()> longPressCallback;
        std::function<void()> shortPressCallback;
        uint32_t pressedTime;
        bool buttonState;
        bool longPressTriggered;
        void buttonChangedCallback(uint8_t pin, uint8_t value);
};